



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux jstack命令详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux jstack命令详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 07:57:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>jstack用于打印出给定的java进程ID或core&nbsp;file或远程调试服务的Java堆栈信息。　　</p>
<p>如果是在64位机器上，需要指定选项"-J-d64"，Windows的jstack使用方式只支持以下的这种方式：jstack&nbsp;[-l]&nbsp;pid</p>
<p>如果java程序崩溃生成core文件，jstack工具可以用来获得core文件的java&nbsp;stack和native&nbsp;stack的信息，从而可以轻松地知道java程序是如何崩溃和在程序何处发生问题。</p>
<p>另外，jstack工具还可以附属到正在运行的java程序中，看到当时运行的java程序的java&nbsp;stack和native&nbsp;stack的信息,&nbsp;如果现在运行的java程序呈现hung的状态，jstack是非常有用的。</p>
<p>需要注意的问题:</p>
<p>l&nbsp;不同的 JAVA虚机的线程 DUMP的创建方法和文件格式是不一样的，不同的 JVM版本， dump信息也有差别。</p>
<p>l&nbsp;在实际运行中，往往一次 dump的信息，还不足以确认问题。建议产生三次 dump信息，如果每次 dump都指向同一个问题，我们才确定问题的典型性。</p>
<p>2、命令格式</p>
<p>$jstack&nbsp;[&nbsp;option&nbsp;]&nbsp;pid</p>
<p>$jstack&nbsp;[&nbsp;option&nbsp;]&nbsp;executable&nbsp;core</p>
<p>$jstack&nbsp;[&nbsp;option&nbsp;]&nbsp;[server-id@]remote-hostname-or-IP</p>
<p>参数说明:</p>
<p>pid: java应用程序的进程号,一般可以通过jps来获得;</p>
<p>executable:产生core&nbsp;dump的java可执行程序;</p>
<p>core:打印出的core文件;</p>
<p>remote-hostname-or-ip:远程debug服务器的名称或IP;</p>
<p>server-id: 唯一id,假如一台主机上多个远程debug服务;</p>
<p>示例:</p>
<p>$jstack &ndash;l 23561</p>
<p>线程分析:</p>
<p>一般情况下，通过jstack输出的线程信息主要包括：jvm自身线程、用户线程等。其中jvm线程会在jvm启动时就会存在。对于用户线程则是在用户访问时才会生成。</p>
<p>l&nbsp;jvm线程：</p>
<p>在线程中，有一些 JVM内部的后台线程，来执行譬如垃圾回收，或者低内存的检测等等任务，这些线程往往在JVM初始化的时候就存在，如下所示：</p>
<div>
<pre class="prettyprint linenums"> "Attach Listener" daemon prio=10 tid=0x0000000052fb8000 nid=0xb8f waiting on condition [0x0000000000000000]

    java.lang.Thread.State: RUNNABLE

    Locked ownable synchronizers:

         - None

 destroyJavaVM" prio=10 tid=0x00002aaac1225800 nid=0x7208 waiting on condition [0x0000000000000000]

    java.lang.Thread.State: RUNNABLE

    Locked ownable synchronizers:

         - None</pre>
</div>
<p>l&nbsp;用户级别的线程</p>
<p>还有一类线程是用户级别的，它会根据用户请求的不同而发生变化。该类线程的运行情况往往是我们所关注的重点。而且这一部分也是最容易产生死锁的地方。</p>
<div>
<pre class="prettyprint linenums"> "qtp496432309-42" prio=10 tid=0x00002aaaba2a1800 nid=0x7580 waiting on condition [0x00000000425e9000]

    java.lang.Thread.State: TIMED_WAITING (parking)

         at sun.misc.Unsafe.park(Native Method)

         - parking to wait for  &lt;0x0000000788cfb020&gt; (a java.util.concurrent.locks.AbstractQueuedSynchronizer$ConditionObject)

         at java.util.concurrent.locks.LockSupport.parkNanos(LockSupport.java:198)

         at java.util.concurrent.locks.AbstractQueuedSynchronizer$ConditionObject.awaitNanos(AbstractQueuedSynchronizer.java:2025)

         at org.eclipse.jetty.util.BlockingArrayQueue.poll(BlockingArrayQueue.java:320)

         at org.eclipse.jetty.util.thread.QueuedThreadPool$2.run(QueuedThreadPool.java:479)

         at java.lang.Thread.run(Thread.java:662)

    Locked ownable synchronizers:

         - None</pre>
</div>
<p>从上述的代码示例中我们可以看到该用户线程的以下几类信息：</p>
<p>&Oslash;&nbsp;线程的状态：waiting on condition(等待条件发生)</p>
<p>&Oslash;&nbsp;线程的调用情况；</p>
<p>&Oslash;&nbsp;线程对资源的锁定情况；</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnw732q.html">用js将从后台得到的时间戳（毫秒数）转换为想要的日期格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxz0zz8.html">在GitHub上管理项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e6e0mq.html">apache ab下载测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zzll18.html">关于git-Git 分支管理和冲突解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okyyjl9.html">转-CMMI在中国之混乱－CMMI比ISO9000会更惨</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k14gzr9.html">window下 Mongodb无法访问28107的有关问题&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xryrn9.html">04、生成 HTMLTestRunner  测试报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1d60x9.html">【转】android 电池（一）：锂电池基本原理篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1wnezq.html">Swift基础之使用Alamofire库进行网络请求和断点下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j146x8.html">Xdoclet &plus; Ant自动生成Hibernate配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp7km69.html">jdbc连接字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2dxvz9.html">SSH防暴力破解脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r1e6j9.html">request请求 HTTPBody 格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rnndz8.html">RNN（3） ------ &OpenCurlyDoubleQuote;blog&colon;RNN学习之路&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvp47k8.html">opencv rtsp 人脸识别</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r3ykm9.html">Java的三种代理模式&lpar;Proxy&comma;CGLib&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2znl08.html">GIt帮助文档之创建新的Git仓库&mdash;&mdash;现有目录下，通过导入所有文件来创建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk04e18.html">python装饰器简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q15rer09.html">第六周 day6 python学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/90dy6do8.html">2-JRE System Libraty &lbrack;eclipse-mars&rsqb;&lpar;unbound&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/1q2ovgl9.html">Bootstrap3&period;0学习第二十五轮&lpar;JavaScript插件&mdash;&mdash;折叠&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ozoml9.html">ECMAScript &mdash;&mdash; 学习笔记（思维导图版）</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv6n618.html">【Javascript】&mdash;&mdash; 1 方法function的高级特性</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2ovox9.html">手把手教你Dojo入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jw6vl8.html">RAID 磁盘状态为foreign，怎么变成ready</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qymnegq.html">【codevs 1200】【NOIP 2012】同余方程   拓展欧几里德求乘法逆元模板题</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw1mp38.html">Cocos2d-X3&period;0 刨根问底（八）----- 场景（Scene&rpar;、层&lpar;Layer&rpar;相关源码分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2oz3v9.html">RequestMethod 相关</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ozmjl9.html">Opencv加载和显示图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zd05v9.html">Android：View中的performClick&lpar;&rpar;触发条件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
